#property indicator_chart_window

extern string  TimeFrame                  = "Current time frame";
extern bool		NoRepaint					   = FALSE;
extern double	MinorMinExtremeHeightATRs	= 2.0;
extern double	MajorToMinorHeightRatio		= 2.5;
extern int		MinorMinExtremeWidth		   = 2;
extern int		MajorMinExtremeWidth		   = 2;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init() { 
   
   //indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);

return(0); }
int start()
{
   Comment("");   
   double valueUp = 0;
   double valueDn = 0;
   
   // ---------
   
      int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
         int position=Bars-counted_bars;
         if (position<0) position=0;
         if (timeFrame!=Period())
         {
            position = MathMin(MathMax(position,3*timeFrame/Period()),Bars-1);
            for (int i=position; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  double value = iCustom(NULL,0,"Extreme_Spike",NoRepaint,MinorMinExtremeHeightATRs,MajorToMinorHeightRatio,MinorMinExtremeWidth,MajorMinExtremeWidth,4,y);
               if (value!=0)
                  {
                     valueUp = iCustom(NULL,0,"Extreme_Spike",NoRepaint,MinorMinExtremeHeightATRs,MajorToMinorHeightRatio,MinorMinExtremeWidth,MajorMinExtremeWidth,0,y);
                     valueDn = iCustom(NULL,0,"Extreme_Spike",NoRepaint,MinorMinExtremeHeightATRs,MajorToMinorHeightRatio,MinorMinExtremeWidth,MajorMinExtremeWidth,1,y);
                     if (valueUp!=0 || valueDn!=0) break;
                  }                  
            if (valueUp!=0) Comment("last peak is SELL and it happend at bar : "+i);
            if (valueDn!=0) Comment("last peak is BUY and it happend at bar : "+i);
            }
            return(0);
         }
   
   
   // ---------
   
}

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}